import { computed, reactive, ref } from 'vue'

import { isOperationReady } from './algo'
import { Operation, Plaquette } from './types'

export const operations = reactive<Operation[]>([])
export const plaquettes = ref<Plaquette[]>([])

export const result = ref(0)

export const currentOperation = computed(
  () => operations[operations.length - 1],
)

export const isEndGame = computed(
  () => operations.length === 5 && isOperationReady(currentOperation.value),
)

export const isResultPerfect = computed(
  () => currentOperation.value.result!.value === result.value,
)
